// --------------------------------------------------------------------
// Copyright (c) 2007 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------


// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Allen  Wang       :| 10/25/10  :| Initial Revision
//   V1.1 :| Tony   Zhou       :| 3/8/2011  :| support to HDMI 1.4

//---------------------------------------------------------------------
`include "vpg_source\vpg.h"



//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================
module DE3_HDMI_TX_RX(

		////////// CLOCK //////////
		OSC_BA,
		OSC_BB,
		OSC_BC,
		OSC_BD,
		OSC1_50,
		OSC2_50,
		CLK_OUT,
		EXT_CLK,

		////////// LED //////////
		LEDR,
		LEDG,
		LEDB,

		////////// BUTTON //////////
		Button,

		////////// HSTCC (J5 HSTC-C TOP/J6, HSTC-C BOTTOM), connect to HDMI(HDMI Board) //////////
		HDMI_RX_I2S,
		HDMI_RX_SCK,
		HDMI_RX_WS,
		HDMI_RX_MCLK,
		HDMI_RX_GD,
		HDMI_RX_HPD_N,
		HDMI_RX_CEC,
		HDMI_RX_RST_N,
		HDMI_RX_SCDT,
		HDMI_RX_SPDIF,
		HDMI_RX_INT_N,
		HDMI_RX_RD,
		HDMI_RX_MUTE,
		HDMI_RX_DSD,
		HDMI_EDID_WP,
		HDMI_RX_PCLK,
		HDMI_RX_BD,
		HDMI_RX_DE,
		HDMI_RX_PCSDA,
		HDMI_RX_HS,
		HDMI_RX_PCSCL,
		HDMI_RX_DDC_SDA,
		HDMI_RX_EVENODD,
		HDMI_RX_DDC_SCL,
		HDMI_RX_VS,
		HDMI_TX_GD,
		HDMI_SDA,
		HDMI_SCL,
		HDMI_TX_RD,
		HDMI_TX_PCSCL,
		HDMI_TX_PCSDA,
		HDMI_TX_RST_N,
		HDMI_TX_INT_N,
		HDMI_TX_DSD_L,
		HDMI_TX_DSD_R,
		HDMI_TX_BD,
		HDMI_TX_PCLK,
		HDMI_TX_DCLK,
		HDMI_TX_SCK,
		HDMI_TX_WS,
		HDMI_TX_MCLK,
		HDMI_TX_I2S,
		HDMI_TX_DE,
		HDMI_TX_VS,
		HDMI_TX_HS,
		HDMI_TX_SPDIF,
		HDMI_TX_CEC,

		////////// REGULATOR //////////
		JVC_CLK,
		JVC_CS,
		JVC_DATAOUT,
		JVC_DATAIN

	);

//=======================================================
//  PARAMETER declarations
//=======================================================

//=======================================================
//  PORT declarations
//=======================================================
////////// CLOCK //////////
input                     		OSC_BA;
input                     		OSC_BB;
input                     		OSC_BC;
input                     		OSC_BD;
input                     		OSC1_50;
input                     		OSC2_50;
output                    		CLK_OUT;
input                     		EXT_CLK;

////////// LED //////////
output    	[7:0]           	LEDR;
output    	[7:0]           	LEDG;
output    	[7:0]           	LEDB;

////////// BUTTON //////////
input     	[3:0]           	Button;

////////// HSTCC (J5 HSTC-C TOP/J6, HSTC-C BOTTOM), connect to HDMI(HDMI Board) //////////
input                     		HDMI_RX_SCK;
input                     		HDMI_RX_WS;
input                     		HDMI_RX_MCLK;
input     	[11:0]          	HDMI_RX_RD;
output                    		HDMI_RX_RST_N;
input                     		HDMI_RX_SCDT;
input                     		HDMI_RX_SPDIF;
input                     		HDMI_RX_INT_N;
input     	[3:0]           	HDMI_RX_I2S;
input                     		HDMI_RX_MUTE;
input                     		HDMI_RX_DSD;
output                    		HDMI_EDID_WP;
input     	[11:0]          	HDMI_RX_GD;
input                     		HDMI_RX_PCLK;
input                     		HDMI_RX_DE;
input     	[11:0]          	HDMI_RX_BD;
inout                     		HDMI_RX_PCSDA;
input                     		HDMI_RX_HS;
output                    		HDMI_RX_PCSCL;
input                     		HDMI_RX_EVENODD;
input                     		HDMI_RX_VS;
inout     	[1:0]           	HDMI_RX_DDC_SDA;
inout     	[1:0]           	HDMI_RX_DDC_SCL;
output    	[1:0]           	HDMI_RX_HPD_N;
inout     	[1:0]           	HDMI_RX_CEC;
output    	[11:0]          	HDMI_TX_RD;
inout                     		HDMI_SDA;
output                    		HDMI_SCL;
output                    		HDMI_TX_PCSCL;
inout                     		HDMI_TX_PCSDA;
output                    		HDMI_TX_RST_N;
input                     		HDMI_TX_INT_N;
output    	[11:0]          	HDMI_TX_GD;
output                    		HDMI_TX_PCLK;
output    	[3:0]           	HDMI_TX_DSD_L;
output    	[3:0]           	HDMI_TX_DSD_R;
output                    		HDMI_TX_DCLK;
output                    		HDMI_TX_SCK;
output                    		HDMI_TX_WS;
output                    		HDMI_TX_MCLK;
output    	[3:0]           	HDMI_TX_I2S;
output    	[11:0]          	HDMI_TX_BD;
output                    		HDMI_TX_DE;
output                    		HDMI_TX_VS;
output                    		HDMI_TX_HS;
output                    		HDMI_TX_SPDIF;
inout                     		HDMI_TX_CEC;

////////// REGULATOR //////////
output                    		JVC_CLK;
output                    		JVC_CS;
output                    		JVC_DATAOUT;
input                     		JVC_DATAIN;



//=======================================================
//  REG/WIRE declarations
//=======================================================

//=======================================================
//  IO Group Voltage Configuration (Do not modify it)
//=======================================================
IOV_A3V3_B3V3_C3V3_D3V3 IOV_Instance(
	.iCLK(OSC2_50),
	.iRST_n(1'b1),
	.iENABLE(1'b0),
	.oREADY(),
	.oERR(),
	.oERRCODE(),
	.oJVC_CLK(JVC_CLK),
	.oJVC_CS(JVC_CS),
	.oJVC_DATAOUT(JVC_DATAOUT),
	.iJVC_DATAIN(JVC_DATAIN)
);

//=======================================================
//  Structural coding
//=======================================================

wire reset_n;
wire pll_100M;

wire gen_sck;
wire gen_i2s;
wire gen_ws;

	


sys_pll sys_pll_inst(
	.areset(1'b0),
	.inclk0(OSC1_50),
	.c0(pll_100M),
	.c1(gen_sck),
	.locked(reset_n)
	);
	
assign LEDR = 8'hFF;  // off
assign LEDG = 8'hFF;  // off
assign LEDB[7:4] = 4'hF;  // off

DE3_SOPC PCI_SOPC_Instance(
                  // 1) global signals:
                   .clk(pll_100M),
                  // .pll_100M(pll_100M),
                   //.pll_i2s_clk(gen_sck),
                   .reset_n(reset_n),

                  // the_pio_button
                   .in_port_to_the_pio_button(Button),

                  // the_pio_led
                   .out_port_from_the_pio_led(LEDB[3:0]),
                   //=========== HDMI RX
                  // the_hdmi_rx_5v
                   .in_port_to_the_hdmi_rx_irq_n(HDMI_RX_INT_N),

                  // the_hdmi_rx_hpd
                   .out_port_from_the_hdmi_rx_hpd_n(HDMI_RX_HPD_N),
                   
                  // the_hdmi_rx_edid_wp
                   .out_port_from_the_hdmi_rx_edid_wp(HDMI_EDID_WP),


                  // the_hdmi_rx_i2c_scl
                   .out_port_from_the_hdmi_rx_i2c_scl(HDMI_RX_PCSCL),

                  // the_hdmi_rx_i2c_sda
                   .bidir_port_to_and_from_the_hdmi_rx_i2c_sda(HDMI_RX_PCSDA),

                  // the_hdmi_rx_reset_n
                   .out_port_from_the_hdmi_rx_reset_n(HDMI_RX_RST_N),                   
                   
                   
                  // the_hdmi_rx0_ep_scl
                   .bidir_port_to_and_from_the_hdmi_rx0_ep_scl(HDMI_RX_DDC_SCL[0]),

                  // the_hdmi_rx0_ep_sda
                   .bidir_port_to_and_from_the_hdmi_rx0_ep_sda(HDMI_RX_DDC_SDA[0]),

                  // the_hdmi_rx1_ep_scl
                   .bidir_port_to_and_from_the_hdmi_rx1_ep_scl(HDMI_RX_DDC_SCL[1]),

                  // the_hdmi_rx1_ep_sda
                   .bidir_port_to_and_from_the_hdmi_rx1_ep_sda(HDMI_RX_DDC_SDA[1]),
                   
                  // the_hdmi_rx_sync
                   .out_port_from_the_hdmi_rx_sync(rx_sync),                   
                   
                   //=========== HDMI TX
                   // hdmi_tx i2c
                   .out_port_from_the_hdmi_tx_i2c_scl(HDMI_TX_PCSCL),
                   .bidir_port_to_and_from_the_hdmi_tx_i2c_sda(HDMI_TX_PCSDA),                     
                   
                   .out_port_from_the_hdmi_tx_reset_n(HDMI_TX_RST_N),
                   .in_port_to_the_hdmi_tx_irq_n(HDMI_TX_INT_N),
                   
                  // the_i2s_tx
                   .i2s_sck_to_the_i2s_tx(gen_sck),
                   .i2s_sd_from_the_i2s_tx(gen_i2s),
                   .i2s_ws_from_the_i2s_tx(gen_ws),
                   
                   .out_port_from_the_hdmi_tx_disp_mode(vpg_disp_mode),
                   .out_port_from_the_hdmi_tx_mode_change(vpg_disp_mode_change),
                   .out_port_from_the_hdmi_tx_vpg_color(vpg_disp_color)
                  
                   
                   
                );




//============== video pattern generator =====================
//wire 		user_change_mode;
wire 		vpg_disp_mode_change;
wire [3:0]	vpg_disp_mode;
wire [1:0]	vpg_disp_color;

wire vpg_pclk;
wire vpg_de;
wire vpg_hs;
wire vpg_vs;
wire [7:0]	vpg_r;
wire [7:0]	vpg_g;
wire [7:0]	vpg_b;


vpg	vpg_inst(
	.clk_100(pll_100M),
	.reset_n(reset_n),
	.mode(vpg_disp_mode),
	.mode_change(vpg_disp_mode_change),
	.disp_color(vpg_disp_color),
	.vpg_pclk(vpg_pclk),
	.vpg_de(vpg_de),
	.vpg_hs(vpg_hs),
	.vpg_vs(vpg_vs),
	.vpg_r(vpg_r),
	.vpg_g(vpg_g),
	.vpg_b(vpg_b)
);

//===== latch hdmi source video
reg	rx_de;
reg	rx_hs;
reg	rx_vs;
reg	[11:0]	rx_r;
reg	[11:0]	rx_g;
reg	[11:0]	rx_b;

always @ (negedge HDMI_RX_PCLK)
begin
	rx_de = HDMI_RX_DE;
	rx_hs = HDMI_RX_HS;
	rx_vs = HDMI_RX_VS;
	rx_r = HDMI_RX_RD;
	rx_g = HDMI_RX_GD;
	rx_b = HDMI_RX_BD;
end


//===== source selection, from pattern generator or hdmi-rx
wire	 rx_sync;


//assign HDMI_TX_PCLK = rx_sync?HDMI_RX_PCLK			:~vpg_pclk; // shift 180 degree for gen clock
clk_slector clk_slector_inst(
	.data0(~vpg_pclk),
	.data1(HDMI_RX_PCLK),
	.sel(rx_sync),
	.result(HDMI_TX_PCLK)
	);

source_selector source_selector_inst(
	.data0x({vpg_de, vpg_hs, vpg_vs, vpg_r, 4'b0000, vpg_g, 4'b0000, vpg_b, 4'b0000}),
	.data1x({rx_de, rx_hs, rx_vs, rx_r,rx_g,rx_b}),
	.sel(rx_sync),
	.result({HDMI_TX_DE, HDMI_TX_HS, HDMI_TX_VS, HDMI_TX_RD,HDMI_TX_GD,HDMI_TX_BD})
	);

//=== audio
assign HDMI_TX_MCLK 	= HDMI_RX_MCLK;
// i2s
assign HDMI_TX_SCK = rx_sync?HDMI_RX_SCK:gen_sck;
assign HDMI_TX_I2S = rx_sync?HDMI_RX_I2S:{gen_i2s, gen_i2s, gen_i2s, gen_i2s};
assign HDMI_TX_WS  = rx_sync?HDMI_RX_WS :gen_ws;

// spdif
//assign HDMI_TX_SPDIF 	= HDMI_RX_SPDIF;
// DSD
//assign HDMI_TX_DCLK 	= HDMI_RX_SCK;
//assign HDMI_TX_DSD_L	= {HDMI_RX_DSD, HDMI_RX_SPDIF, HDMI_RX_I2S[2], HDMI_RX_I2S[0]};
//assign HDMI_TX_DSD_R	= {HDMI_RX_MUTE, HDMI_RX_I2S[3], HDMI_RX_I2S[1], HDMI_RX_WS};




//================================================


endmodule
